# Guide du contributeur

* [Liste des façons de contribuer à YunoHost](/contribute)
* [Écrire de la documentation](/write_documentation)
  *  [Guide de redaction de la documentation](/doc_writing_guide)
  *  [Guide Markdown](/doc_markdown_guide)
  *  [Propulser son code avec Git & GitHub](/doc_use_git)
* [Salons de discussion](/chat_rooms)
* Packaging d'application
   * [Liste d'applications souhaitées par la communauté](/apps_wishlist)
   * [Introduction générale au packaging d'apps](/packaging_apps_start)
   * [Introduction technique au packaging d'apps](/packaging_apps)
   * [Comment utiliser Git pour packager les applications](/packaging_apps_git)
   * [Déployer un environnement de développement avec VirtualBox](/packaging_apps_virtualbox)
   * [Manifest](/packaging_apps_manifest)
   * [Scripts](/packaging_apps_scripts)
   * [Gestion des arguments](/packaging_apps_arguments_management)
   * [Format des arguments](#/packaging_apps_arguments_format)
   * [Configuration nginx](/packaging_apps_nginx_conf)
   * [Multi-instance](/packaging_apps_multiinstance)
   * [Fonctions utiles](/packaging_apps_helpers)
   * [Utilisation de 'trap'](/packaging_apps_trap)
   * [Ajouter son application à la liste des apps](https://github.com/YunoHost/Apps/#contributing)
   * [Feature de packaging avancées](#/packaging_apps_advanced)
       * [Actions pour une application](#/packaging_apps_actions)
       * [Panneau de configuration pour une application](#/packaging_apps_config_panel)
   * Tests de qualité
       * [Package linter](https://github.com/YunoHost/package_linter)
       * [Package check](https://github.com/YunoHost/package_check)
       * [Niveaux des applications](/packaging_apps_levels)
       * [Intégration continue des apps](https://ci-apps.yunohost.org)
       * [Tableau de bord du CI des apps](https://dash.yunohost.org/appci/branch/stable)
       * [Intégration continue pour packagers](/packaging_apps_ci)
       * [YEP - YunoHost Enhancement Proposals](/packaging_apps_guidelines)
* [Contribuer à la partie "core" de YunoHost](/dev)
   * [Déployer un environnement de dev avec ynh-dev](https://github.com/YunoHost/ynh-dev/blob/master/README.md)
   * [Construction des paquets debian](https://github.com/YunoHost/vinaigrette/blob/master/README.md)
   * [Feuilles de route du projet](https://github.com/YunoHost/issues/milestones?direction=asc&sort=title&state=open)
   * Construction des images
       * [x86 ISO](https://github.com/YunoHost/cd_build)
       * [Images Raspberry Pi](https://github.com/YunoHost/rpi-image)
       * [Autres images pour cartes ARM](https://github.com/YunoHost/arm-images)
* [Utiliser l'API YunoHost en dehors de la webadmin](/admin_api)
* [Une discussion sur la portée des variables en bash](shell_variables_scope)
